Subject: Re: Qualcomm rmnet driver and qmi_wwan

From: Subash Abhinov Kasiviswanathan <[email-masked]>
Date: Wed, 21 Feb 2018 12:47:40 -0700

On 2018-02-21 04:38, Daniele Palmas wrote:
> Hello,
> 
> in rmnet kernel documentation I read:
> 
> "This driver can be used to register onto any physical network device 
> in
> IP mode. Physical transports include USB, HSIC, PCIe and IP 
> accelerator."
> 
> Does this mean that it can be used in association with the qmi_wwan 
> driver?
> 
> If yes, can someone give me an hint on the steps to follow?
> 
> If not, does anyone know if it is possible to modify qmi_wwan in order
> to take advantage of the features provided by the rmnet driver?
> 
> In this case hint on the changes for modifying qmi_wwan are welcome.
> 
> Thanks in advance,
> Daniele

Hi

I havent used qmi_wwan so the following comment is based on code 
inspection.
qmimux_register_device() is creating qmimux devices with usb net device 
as
real_dev. The Multiplexing and aggregation header (qmimux_hdr) is 
stripped off
in qmimux_rx_fixup() and the packet is passed on to stack.

You could instead create rmnet devices with the usb netdevice as real 
dev.
The packets from the usb net driver can be queued to network stack 
directly
as rmnet driver will setup a RX handler. rmnet driver will process the 
packets
further and then queue to network stack.

-- 
Qualcomm Innovation Center, Inc. is a member of Code Aurora Forum,
a Linux Foundation Collaborative Project